%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                         PSG Type    PSG Object                Location in Problem Statement                                                     Class
%matrix_data_benchmark          bench       matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_data_data               data        matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_data_vars               vars        matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       cell
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_linear_data             data        matrix_linear             linear(matrix_linear)                                                             double
%matrix_linear_vars             vars        matrix_linear             linear(matrix_linear)                                                             cell
%matrix_parameters_vars_data    data        matrix_parameters_vars    logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_parameters_vars_vars    vars        matrix_parameters_vars    logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       cell
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_data_benchmark,matrix_data_data,matrix_data_vars,matrix_linear_data,matrix_linear_vars,matrix_parameters_vars_data,matrix_parameters_vars_vars)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_data',matrix_data_data,matrix_data_vars,matrix_data_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_linear',matrix_linear_data,matrix_linear_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_parameters_vars',matrix_parameters_vars_data,matrix_parameters_vars_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))',...
'constraint: <= 10',...
'  linear(matrix_linear)',...
'',...
'calculate',...
'Point: point_problem_1',...
'  logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))',...
'  logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))',...
' ');
%Change parameters with their values in problem statement:

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

